--코드 5-1 테이블 생성 실습
CREATE TABLE TB_RN_TMP --도로명임시
(
  RN_CD VARCHAR2(12) NOT NULL --도로명코드
, RN VARCHAR2(150) NOT NULL --도로명
);

--코드 5-2 부모 테이블 생성
CREATE TABLE TB_SUBWAY_STATN_TMP --지하철역임시
(
  SUBWAY_STATN_NO CHAR(6) NOT NULL --지하철역번호
, LN_NM VARCHAR2(50) NOT NULL --노선명
, STATN_NM VARCHAR2(50) NOT NULL --역명
--지하철역번호를 PK로 지정
, CONSTRAINT PK_TB_SUBWAY_STATN_TMP PRIMARY KEY(SUBWAY_STATN_NO)
);

--코드 5-3 자식 테이블 생성
CREATE TABLE TB_SUBWAY_STATN_TK_GFF_TMP --지하철역승하차임시
(
  SUBWAY_STATN_NO CHAR(6) NOT NULL --지하철역번호
, STD_YM CHAR(6) NOT NULL --기준년월
, BEGIN_TIME CHAR(4) NOT NULL --시작시간
, END_TIME CHAR(4) NOT NULL --종료시간
, TK_GFF_SE_CD VARCHAR2(6) NOT NULL --승하차구분코드
, TK_GFF_CNT NUMBER(15) NOT NULL --승하차횟수
, CONSTRAINT PK_TB_SUBWAY_STATN_TK_GFF_TMP PRIMARY KEY (SUBWAY_STATN_NO, STD_YM, BEGIN_TIME, END_TIME, TK_GFF_SE_CD)
);

--코드 5-4 외래키 생성
ALTER TABLE TB_SUBWAY_STATN_TK_GFF_TMP --지하철역승하차임시 테이블에
ADD CONSTRAINT FK_TB_SUBWAY_STATN_TK_GFF_TMP1 --참조 무결성 제약조건을 생성
FOREIGN KEY (SUBWAY_STATN_NO) --지하철역승하차임시 테이블의 지하철역번호 칼럼은
--지하철역임시 테이블의 지하철역번호를 참조
REFERENCES TB_SUBWAY_STATN_TMP (SUBWAY_STATN_NO);

--코드 5-5 칼럼 추가
ALTER TABLE TB_SUBWAY_STATN_TMP ADD (OPER_YN CHAR(1)); --운영여부 칼럼 추가

--코드 5-6 칼럼 제거
ALTER TABLE TB_SUBWAY_STATN_TMP DROP COLUMN OPER_YN;

--코드 5-7 데이터형 및 제약조건 변경
--운영여부 칼럼 추가생성 (NULL 허용)
ALTER TABLE TB_SUBWAY_STATN_TMP ADD (OPER_YN CHAR(1) NULL);
--운영여부 칼럼 변경
ALTER TABLE TB_SUBWAY_STATN_TMP MODIFY(OPER_YN NUMBER(1) DEFAULT 0 NOT NULL NOVALIDATE);

--코드 5-8 칼럼명 변경
ALTER TABLE TB_SUBWAY_STATN_TMP RENAME COLUMN OPER_YN TO OPERATION_YN;

--코드 5-9 외래키 제거
ALTER TABLE TB_SUBWAY_STATN_TK_GFF_TMP
DROP CONSTRAINT FK_TB_SUBWAY_STATN_TK_GFF_TMP1;


--코드 5-10 외래키 생성
ALTER TABLE TB_SUBWAY_STATN_TK_GFF_TMP --지하철역승하차임시 테이블에
ADD CONSTRAINT FK_TB_SUBWAY_STATN_TK_GFF_TMP1 --참조 무결성 제약조건을 생성
FOREIGN KEY ( SUBWAY_STATN_NO ) --지하철역승하차임시 테이블의 지하철역번호 칼럼은
--지하철역임시 테이블의 지하철역번호를 참조
REFERENCES TB_SUBWAY_STATN_TMP (SUBWAY_STATN_NO );

--코드 5-11 테이블명 변경
RENAME TB_SUBWAY_STATN_TK_GFF_TMP TO TB_SUBWAY_STATN_TK_GFF_TMP_2;

--코드 5-12 테이블 내 데이터 제거
TRUNCATE TABLE TB_SUBWAY_STATN_TK_GFF_TMP_2;

--코드 5-13 테이블 제거
DROP TABLE TB_SUBWAY_STATN_TK_GFF_TMP_2;
DROP TABLE TB_SUBWAY_STATN_TMP;
DROP TABLE TB_RN_TMP;