-----------------------------------------------------------------------------------------------------------------
--51.
CREATE TABLE TB_DEPT_51
(
  DEPT_NO CHAR(4)
, DEPT_NM VARCHAR(50)
, CONSTRAINT TB_DEPT_51_PK PRIMARY KEY (DEPT_NO)
);

INSERT INTO TB_DEPT_51 (DEPT_NO, DEPT_NM ) VALUES ( 'D101', '데이터개발팀');
INSERT INTO TB_DEPT_51 (DEPT_NO, DEPT_NM ) VALUES ( 'D102', '파이썬개발팀');

COMMIT;

CREATE TABLE TB_EMP_51
(
  EMP_NO CHAR(4)
, EMP_NM VARCHAR2(50) NOT NULL
, JOB_NM VARCHAR2(50) NOT NULL
, DEPT_NO CHAR(4)
, CONSTRAINT TB_EMP_51_PK PRIMARY KEY (EMP_NO)
)
;

ALTER TABLE TB_EMP_51
ADD CONSTRAINTS FK_TB_EMP_51 FOREIGN KEY (DEPT_NO)
REFERENCES TB_DEPT_51 (DEPT_NO)
;

INSERT INTO TB_EMP_51 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E001', '이경오', 'SQL개발자', 'D101');
INSERT INTO TB_EMP_51 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E002', '이수지', 'SQL개발자', 'D101');
INSERT INTO TB_EMP_51 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E003', '김선태', '파이썬개발자', 'D102');
INSERT INTO TB_EMP_51 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E004', '김지선', '파이썬개발자', 'D102');
INSERT INTO TB_EMP_51 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E005', '박선정', '파이썬개발자', 'D102');
INSERT INTO TB_EMP_51 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E006', '박선정', '자바개발자', NULL);

COMMIT;

SELECT NVL(B.EMP_NO , '(Null)') AS B_EMP_NO
     , NVL(B.EMP_NM , '(Null)') AS B_EMP_NM
     , NVL(B.JOB_NM , '(Null)') AS B_JOB_NM
     , NVL(B.DEPT_NO, '(Null)') AS B_DEPT_NO
     , NVL(A.DEPT_NO, '(Null)') AS A_DEPT_NO
     , NVL(A.DEPT_NM, '(Null)') AS A_DEPT_NM
  FROM TB_DEPT_51 A RIGHT OUTER JOIN TB_EMP_51 B
  ON (
          A.DEPT_NO = B.DEPT_NO AND A.DEPT_NO = 'D101'
      AND B.DEPT_NO IS NOT NULL
     )
  ORDER BY B.EMP_NO
  ;

-------------------------------------------------------------------------------------------------------------
--52.
CREATE TABLE TB_DEPT_52
(
  DEPT_NO CHAR(4)
, DEPT_NM VARCHAR(50)
);

INSERT INTO TB_DEPT_52 (DEPT_NO, DEPT_NM ) VALUES ( 'D101', '데이터개발팀');
INSERT INTO TB_DEPT_52 (DEPT_NO, DEPT_NM ) VALUES ( 'D102', '파이썬개발팀');
INSERT INTO TB_DEPT_52 (DEPT_NO, DEPT_NM ) VALUES ( NULL  , '자바개발팀');

COMMIT;

CREATE TABLE TB_EMP_52
(
  EMP_NO CHAR(4)
, EMP_NM VARCHAR2(50) NOT NULL
, JOB_NM VARCHAR2(50) NOT NULL
, DEPT_NO CHAR(4)
)
;

INSERT INTO TB_EMP_52 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E001', '이경오', 'SQL개발자', 'D101');
INSERT INTO TB_EMP_52 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E002', '이수지', 'SQL개발자', 'D101');
INSERT INTO TB_EMP_52 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E003', '김선태', '파이썬개발자', NULL);
INSERT INTO TB_EMP_52 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E004', '김지선', '파이썬개발자', 'D102');
INSERT INTO TB_EMP_52 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E005', '박선정', '파이썬개발자', 'D102');
INSERT INTO TB_EMP_52 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E006', '박선정', '자바개발자', NULL);

COMMIT;


SELECT NVL(A.DEPT_NO , '(Null)') AS A_DEPT_NO
     , NVL(A.DEPT_NM , '(Null)') AS A_DEPT_NM
     , NVL(B.EMP_NO  , '(Null)') AS B_EMP_NO
     , NVL(B.EMP_NM  , '(Null)') AS B_EMP_NM
     , NVL(B.JOB_NM  , '(Null)') AS B_JOB_NM
     , NVL(B.DEPT_NO , '(Null)') AS B_DEPT_NO
FROM TB_DEPT_52 A FULL OUTER JOIN TB_EMP_52 B
ON (A.DEPT_NO = B.DEPT_NO)
ORDER BY A.DEPT_NO DESC
;
-------------------------------------------------------------------------------------------------------------
--54.
CREATE TABLE TB_ORD_54
(
      ORD_NO CHAR(8)
    , ORD_DE CHAR(8)
    , ORD_TM CHAR(6)
    , PRDT_CD CHAR(4)
    , ORD_CNT NUMBER(10)
    , ORD_AMT NUMBER(10)
    , CONSTRAINT TB_ORD_54_PK PRIMARY KEY (ORD_NO)
)
;

INSERT INTO TB_ORD_54 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
     VALUES ('10000001', '20201113', '103610', 'P001', 1, 42000);
INSERT INTO TB_ORD_54 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
     VALUES ('10000002', '20201113', '103756', 'P001', 1, 42000);
INSERT INTO TB_ORD_54 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
     VALUES ('10000003', '20201113', '103757', 'P002', 1, 38000);
INSERT INTO TB_ORD_54 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
     VALUES ('10000004', '20201113', '103814', 'P002', 1, 38000);
INSERT INTO TB_ORD_54 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
     VALUES ('10000005', '20201113', '103942', 'P003', 1, 56000);

COMMIT;

SELECT PRDT_CD FROM TB_ORD_54 WHERE PRDT_CD = 'P001'
UNION ALL
SELECT PRDT_CD FROM TB_ORD_54 WHERE PRDT_CD = 'P002'
MINUS
SELECT PRDT_CD FROM TB_ORD_54 WHERE PRDT_CD = 'P003'
ORDER BY PRDT_CD DESC
;
-------------------------------------------------------------------------------------------------------------
--55.
CREATE TABLE TB_DEPT_55
(
  DEPT_NO CHAR(4)
, DEPT_NM VARCHAR2(50) NOT NULL
, UPPER_DEPT_NO CHAR(4) NULL
, CONSTRAINT TB_DEPT_55_PK PRIMARY KEY(DEPT_NO)
)
;

INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D001', '회장실', NULL);
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D002', '기술본부', 'D001');
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D003', '데이터기술사업부', 'D002');
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D004', 'SQL개발팀', 'D003');
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D005', '파이썬개발팀', 'D003');
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D006', 'R개발팀', 'D003');

INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D007', '영업본부', 'D001');
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D008', '기업영업부', 'D007');
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D009', '대기업영업팀', 'D008');
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D010', '중견기업영업팀', 'D008');
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D011', '중소기업영업팀', 'D008');

COMMIT;

SELECT DEPT_NO
     , LPAD(' ', 4 * (LEVEL -1)) || DEPT_NM AS DEPT_NM
     , NVL(UPPER_DEPT_NO, '최상위부서') AS UPPER_DEPT_NO
  FROM TB_DEPT_55
  START WITH UPPER_DEPT_NO IS NOT NULL
  CONNECT BY PRIOR DEPT_NO = UPPER_DEPT_NO
;

SELECT DEPT_NO
     , LPAD(' ', 4 * (LEVEL -1)) || DEPT_NM AS DEPT_NM
     , NVL(UPPER_DEPT_NO, '최상위부서') AS UPPER_DEPT_NO
  FROM TB_DEPT_55
  START WITH UPPER_DEPT_NO IS NOT NULL
  CONNECT BY DEPT_NO = PRIOR UPPER_DEPT_NO
;


SELECT DEPT_NO
     , LPAD(' ', 4 * (LEVEL -1)) || DEPT_NM AS DEPT_NM
     , NVL(UPPER_DEPT_NO, '최상위부서') AS UPPER_DEPT_NO
  FROM TB_DEPT_55
  START WITH UPPER_DEPT_NO IS NULL
  CONNECT BY DEPT_NO = PRIOR UPPER_DEPT_NO
;

SELECT DEPT_NO
     , LPAD(' ', 4 * (LEVEL -1)) || DEPT_NM AS DEPT_NM
     , NVL(UPPER_DEPT_NO, '최상위부서') AS UPPER_DEPT_NO
  FROM TB_DEPT_55
  START WITH UPPER_DEPT_NO IS NULL
  CONNECT BY PRIOR DEPT_NO = UPPER_DEPT_NO
;

-------------------------------------------------------------------------------------------------------------
--55.
SELECT ROWNUM AS RNUM
FROM DUAL
CONNECT BY LEVEL <= 10;

-------------------------------------------------------------------------------------------------------------
--58.
CREATE TABLE TB_ORD_58
(
  ORD_NO CHAR(8)
, ORD_DE CHAR(8)
, ORD_TM CHAR(6)
, PRDT_CD CHAR(4)
, ORD_CNT NUMBER(10)
, ORD_AMT NUMBER(10)
, CONSTRAINT TB_ORD_58_PK PRIMARY KEY (ORD_NO)
)
;

INSERT INTO TB_ORD_58 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
VALUES ('10000001', '20201113', '103610', 'P001', 1, 42000);
INSERT INTO TB_ORD_58 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
VALUES ('10000002', '20201113', '103756', 'P001', 1, 42000);
INSERT INTO TB_ORD_58 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
VALUES ('10000003', '20201113', '103757', 'P002', 1, 38000);
INSERT INTO TB_ORD_58 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
VALUES ('10000004', '20201113', '103814', 'P002', 1, 38000);
INSERT INTO TB_ORD_58 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
VALUES ('10000005', '20201113', '103942', 'P003', 1, 56000);

COMMIT;

SELECT NVL(SUM(A.ORD_AMT), '0') AS TOT_ORD_AMT
FROM TB_ORD_58 A
WHERE A.ORD_AMT >= ( SELECT AVG(K.ORD_AMT)
                   FROM TB_ORD_58 K
                  WHERE K.PRDT_CD = 'P001'
               );
-------------------------------------------------------------------------------------------------------------
--60.
CREATE TABLE TB_CUST_60
(
  CUST_NO CHAR(7)
, CUST_NM VARCHAR2(50) NOT NULL
, JOB_NM VARCHAR2(50) NULL
, CONSTRAINT TB_CUST_60_PK PRIMARY KEY (CUST_NO)
)
;

INSERT INTO TB_CUST_60 (CUST_NO, CUST_NM, JOB_NM) VALUES ('1000001', '이경오', 'SQL개발자');
INSERT INTO TB_CUST_60 (CUST_NO, CUST_NM, JOB_NM) VALUES ('1000002', '이수지', '파이썬개발자');
INSERT INTO TB_CUST_60 (CUST_NO, CUST_NM, JOB_NM) VALUES ('1000003', '최혁진', NULL);

CREATE TABLE TB_PRDT_60
(
  PRDT_CD CHAR(4)
, PRDT_NM VARCHAR2(50) NOT NULL
, PRDT_PRC NUMBER(10)
, CONSTRAINT TB_PRDT_60_PK PRIMARY KEY (PRDT_CD)
)
;

INSERT INTO TB_PRDT_60 (PRDT_CD, PRDT_NM, PRDT_PRC ) VALUES ('P001', 'LG그램15인치', 1580000);
INSERT INTO TB_PRDT_60 (PRDT_CD, PRDT_NM, PRDT_PRC ) VALUES ('P002', '삼성아티브15인치', 1680000);


CREATE TABLE TB_ORD_60
(
  ORD_NO CHAR(8)
, ORD_DT DATE NOT NULL
, CUST_NO CHAR(7) NOT NULL
, PRDT_CD CHAR(4) NOT NULL
, ORD_CNT NUMBER(10)
, ORD_AMT NUMBER(10)
, CONSTRAINT TB_ORD_60_PK PRIMARY KEY (ORD_NO)
)
;

INSERT INTO TB_ORD_60 (ORD_NO, ORD_DT, CUST_NO, PRDT_CD, ORD_CNT, ORD_AMT  )
     VALUES ('10000001', TO_DATE('20201113145812', 'YYYYMMDDHH24MISS'), '1000001', 'P001', 1, 1580000);

INSERT INTO TB_ORD_60 (ORD_NO, ORD_DT, CUST_NO, PRDT_CD, ORD_CNT, ORD_AMT  )
     VALUES ('10000002', TO_DATE('20201113154457', 'YYYYMMDDHH24MISS'), '1000002', 'P002', 2, 3360000);

INSERT INTO TB_ORD_60 (ORD_NO, ORD_DT, CUST_NO, PRDT_CD, ORD_CNT, ORD_AMT  )
     VALUES ('10000003', TO_DATE('20201113182212', 'YYYYMMDDHH24MISS'), '1000003', 'P002', 1, 1680000);


COMMIT;

SELECT A.JOB_NM, B.PRDT_CD, COUNT(*) AS CNT, SUM(B.ORD_AMT) AS ORD_AMT_TOT
FROM TB_CUST_60 A
   , TB_ORD_60 B
   , TB_PRDT_60 C
WHERE A.CUST_NO = B.CUST_NO
AND B.PRDT_CD = C.PRDT_CD
GROUP BY ROLLUP(A.JOB_NM, B.PRDT_CD)
;

-------------------------------------------------------------------------------------------------------------
--63.
CREATE TABLE TB_EMP_63
(
  EMP_NO CHAR(4)
, EMP_NM VARCHAR2(50) NOT NULL
, DEPT_NO CHAR(4) NOT NULL
, DEPT_NM VARCHAR2(50) NOT NULL
, CUR_SAL NUMBER(10)
, CONSTRAINT TB_EMP_63_PK PRIMARY KEY (EMP_NO)
)
;


INSERT INTO TB_EMP_63 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E001', '이경오', 'D001', 'SQL개발팀', 75000000);
INSERT INTO TB_EMP_63 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E002', '이수지', 'D001', 'SQL개발팀', 70000000);
INSERT INTO TB_EMP_63 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E003', '김혜원', 'D001', 'SQL개발팀', 70000000);
INSERT INTO TB_EMP_63 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E004', '박문수', 'D001', 'SQL개발팀', 75000000);
INSERT INTO TB_EMP_63 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E005', '최현민', 'D003', 'SQL튜닝팀', 95000000);

COMMIT;

SELECT EMP_NO
    , DEPT_NO
    , CUR_SAL
    , RANK() OVER(PARTITION BY DEPT_NO ORDER BY CUR_SAL DESC) AS RN1
    , DENSE_RANK() OVER(PARTITION BY DEPT_NO ORDER BY CUR_SAL DESC) AS RN2
    , ROW_NUMBER() OVER(PARTITION BY DEPT_NO ORDER BY CUR_SAL DESC) AS RN3
FROM TB_EMP_63
;

-------------------------------------------------------------------------------------------------------------
--64.
CREATE TABLE TB_EMP_64
(
  EMP_NO CHAR(4)
, EMP_NM VARCHAR2(50) NOT NULL
, DEPT_NO CHAR(4) NOT NULL
, DEPT_NM VARCHAR2(50) NOT NULL
, CUR_SAL NUMBER(10)
, CONSTRAINT TB_EMP_64_PK PRIMARY KEY (EMP_NO)
)
;


INSERT INTO TB_EMP_64 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E001', '이경오', 'D001', 'SQL개발팀', 55000000);
INSERT INTO TB_EMP_64 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E002', '이수지', 'D001', 'SQL개발팀', 60000000);
INSERT INTO TB_EMP_64 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E003', '김혜원', 'D001', 'SQL개발팀', 65000000);
INSERT INTO TB_EMP_64 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E004', '박문수', 'D001', 'SQL개발팀', 70000000);
INSERT INTO TB_EMP_64 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E005', '최현민', 'D003', 'SQL튜닝팀', 75000000);
INSERT INTO TB_EMP_64 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E006', '최현민', 'D003', 'SQL튜닝팀', 80000000);

COMMIT;

SELECT EMP_NO
     , EMP_NM
     , NTILE(6) OVER(ORDER BY CUR_SAL DESC) AS RN1
     , ROW_NUMBER() OVER(ORDER BY CUR_SAL DESC) AS RN2
     , RANK() OVER(ORDER BY CUR_SAL DESC) AS RN3
     , DENSE_RANK() OVER(ORDER BY CUR_SAL DESC) AS RN4
  FROM TB_EMP_64
;

-------------------------------------------------------------------------------------------------------------
--65.
CREATE TABLE TB_EMP_65
(
  EMP_NO CHAR(4)
, EMP_NM VARCHAR2(50) NOT NULL
, DEPT_NO CHAR(4) NOT NULL
, DEPT_NM VARCHAR2(50) NOT NULL
, CUR_SAL NUMBER(10)
, CONSTRAINT TB_EMP_65_PK PRIMARY KEY (EMP_NO)
)
;


INSERT INTO TB_EMP_65 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E001', '이경오', 'D001', 'SQL개발팀', 55000000);

INSERT INTO TB_EMP_65 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E002', '이수지', 'D001', 'SQL개발팀', 60000000);

INSERT INTO TB_EMP_65 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E003', '김혜원', 'D001', 'SQL개발팀', NULL);

INSERT INTO TB_EMP_65 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E004', '박문수', 'D002', 'SQL튜닝팀', 70000000);

INSERT INTO TB_EMP_65 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E005', '최현민', 'D002', 'SQL튜닝팀', 75000000);

INSERT INTO TB_EMP_65 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E007', '이검수', 'D002', 'SQL튜닝팀', NULL);


COMMIT;

SELECT
       A.EMP_NO
     , A.EMP_NM
     , A.DEPT_NO
     , NVL(TO_CHAR(A.MAX_CUR_SAL), '(Null)') AS MAX_CUR_SAL
  FROM
(
SELECT EMP_NO
     , EMP_NM
     , DEPT_NO
     , MAX(CUR_SAL) OVER(PARTITION BY DEPT_NO ORDER BY CUR_SAL DESC) AS MAX_CUR_SAL
  FROM TB_EMP_65
) A
;
-------------------------------------------------------------------------------------------------------------
--70.
CREATE TABLE TB_EMP_70
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, JOB_NM VARCHAR2(150) NULL
, CUR_SAL NUMBER
, DEPT_CD CHAR(4)
, CONSTRAINT TB_EMP_70_PK PRIMARY KEY(EMP_NO)
)
;


INSERT INTO TB_EMP_70 VALUES ('100001', '이경오', 'SQL개발자'     , 80000000, 'D101');
INSERT INTO TB_EMP_70 VALUES ('100002', '이동민', '프로시저개발자', 60000000, 'D101');

INSERT INTO TB_EMP_70 VALUES ('100003', '김철수', '리눅스엔지니어', 40000000, 'D102');
INSERT INTO TB_EMP_70 VALUES ('100004', '박상진', '윈도우엔지니어', 20000000, 'D102');

COMMIT;

SELECT A.EMP_NO
     , A.EMP_NM
     , NTILE(2) OVER (ORDER BY CUR_SAL DESC) AS CUR_SAL_SE
     , CUR_SAL
  FROM TB_EMP_70 A
;
-------------------------------------------------------------------------------------------------------------
--71.
CREATE TABLE TB_EMP_71
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, SEX_CD CHAR(1)
, BIRTH_DE CHAR(8) NOT NULL
, DEPT_CD CHAR(4)
);

ALTER TABLE TB_EMP_71
ADD CONSTRAINT TB_EMP_71_PK PRIMARY KEY (EMP_NO);

INSERT INTO TB_EMP_71 (EMP_NO, EMP_NM, SEX_CD, BIRTH_DE, DEPT_CD)
VALUES ('E00001', '이경오', '1', '19840718', 'D001');
INSERT INTO TB_EMP_71 (EMP_NO, EMP_NM, SEX_CD, BIRTH_DE, DEPT_CD)
VALUES ('E00002', '이수지', '2', '19940502', 'D001');
INSERT INTO TB_EMP_71 (EMP_NO, EMP_NM, SEX_CD, BIRTH_DE, DEPT_CD)
VALUES ('E00003', '박경민', '1', '19830414', 'D002');
INSERT INTO TB_EMP_71 (EMP_NO, EMP_NM, SEX_CD, BIRTH_DE, DEPT_CD)
VALUES ('E00004', '최주연', '2', '19920508', 'D002');
INSERT INTO TB_EMP_71 (EMP_NO, EMP_NM, SEX_CD, BIRTH_DE, DEPT_CD)
VALUES ('E00005', '최철순', '1', '19860112', 'D003');
INSERT INTO TB_EMP_71 (EMP_NO, EMP_NM, SEX_CD, BIRTH_DE, DEPT_CD)
VALUES ('E00006', '이지연', '2', '19960218', 'D003');
INSERT INTO TB_EMP_71 (EMP_NO, EMP_NM, SEX_CD, BIRTH_DE, DEPT_CD)
VALUES ('E00007', '차은영', '2', '19980218',  NULL );

COMMIT;

SELECT EMP_NO, EMP_NM, SEX_CD, COUNT(DEPT_CD) OVER(PARTITION BY SEX_CD) AS CNT
  FROM TB_EMP_71
  ORDER BY EMP_NO
;
-------------------------------------------------------------------------------------------------------------
--72.
CREATE TABLE TB_EMP_72
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, JOB_NM VARCHAR2(150) NULL
, CUR_SAL NUMBER
, DEPT_CD CHAR(4)
, CONSTRAINT TB_EMP_72_PK PRIMARY KEY(EMP_NO)
);

INSERT INTO TB_EMP_72 VALUES ('100001', '이경오', 'SQL개발자', 45000000, 'D101');
INSERT INTO TB_EMP_72 VALUES ('100002', '이동민', 'SQL개발자', 40000000, 'D101');
INSERT INTO TB_EMP_72 VALUES ('100003', '김철수', 'SQL개발자', 40000000, 'D102');
INSERT INTO TB_EMP_72 VALUES ('100004', '박상진', 'SQL개발자', 35000000, 'D102');
INSERT INTO TB_EMP_72 VALUES ('100005', '박은정', 'SQL개발자', 50000000, 'D103');
INSERT INTO TB_EMP_72 VALUES ('100006', '김다연', 'SQL개발자', 45000000, 'D103');
INSERT INTO TB_EMP_72 VALUES ('100007', '박수진', 'SQL개발자', 65000000, 'D104');
INSERT INTO TB_EMP_72 VALUES ('100008', '김성수', 'SQL개발자', 60000000, 'D104');
INSERT INTO TB_EMP_72 VALUES ('100009', '추상미', 'SQL개발자', 35000000, 'D105');
INSERT INTO TB_EMP_72 VALUES ('100010', '박나래', 'SQL개발자', 30000000, 'D105');

COMMIT;


SELECT SUM(DENSE_RANK_CUR_SAL) SUM_DENSE_RANK_CUR_SAL
  FROM
     (
      SELECT DISTINCT DENSE_RANK() OVER (ORDER BY CUR_SAL) DENSE_RANK_CUR_SAL
        FROM TB_EMP_72
     )
;
-------------------------------------------------------------------------------------------------------------
--74.
CREATE TABLE TB_DEPT_74
(
  DEPT_CD CHAR(4)
, DEPT_NM VARCHAR2(150) NOT NULL
, CONSTRAINT TB_DEPT_74_PK PRIMARY KEY(DEPT_CD)
)
;

CREATE TABLE TB_EMP_74
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, JOB_NM VARCHAR2(150) NULL
, CUR_SAL NUMBER
, DEPT_CD CHAR(4)
, CONSTRAINT TB_EMP_74_PK PRIMARY KEY(EMP_NO)
)
;

ALTER TABLE TB_EMP_74
ADD CONSTRAINT TB_EMP_74_FK FOREIGN KEY (DEPT_CD)
   REFERENCES TB_DEPT_74 (DEPT_CD);

INSERT INTO TB_DEPT_74 VALUES ('D101', '데이터개발팀'        );
INSERT INTO TB_DEPT_74 VALUES ('D102', '데이터플랫폼팀'      );
INSERT INTO TB_DEPT_74 VALUES ('D103', '데이터사이언스팀'    );
INSERT INTO TB_DEPT_74 VALUES ('D104', '데이터성능팀'        );
INSERT INTO TB_DEPT_74 VALUES ('D105', '데이터마이그레이션팀');

COMMIT;

INSERT INTO TB_EMP_74 VALUES ('100001', '이경오', 'SQL개발자'     , 45000000, 'D101');
INSERT INTO TB_EMP_74 VALUES ('100002', '이동민', '프로시저개발자', 40000000, 'D101');

INSERT INTO TB_EMP_74 VALUES ('100003', '김철수', '리눅스엔지니어', 40000000, 'D102');
INSERT INTO TB_EMP_74 VALUES ('100004', '박상진', '윈도우엔지니어', 35000000, 'D102');


INSERT INTO TB_EMP_74 VALUES ('100005', '박은정', 'R개발자'       , 50000000, 'D103');
INSERT INTO TB_EMP_74 VALUES ('100006', '김다연', '파이썬개발자'  , 45000000, 'D103');


INSERT INTO TB_EMP_74 VALUES ('100007', '박수진', '오라클튜너'    , 65000000, 'D104');
INSERT INTO TB_EMP_74 VALUES ('100008', '김성수', '오픈소스튜너'  , 60000000, 'D104');

INSERT INTO TB_EMP_74 VALUES ('100009', '추상미', '쉘개발자'      , 35000000, 'D105');
INSERT INTO TB_EMP_74 VALUES ('100010', '박나래', '자바개발자'    , 30000000, 'D105');

COMMIT;

SELECT B.DEPT_NM
     , AVG(A.CUR_SAL) AS CUR_SAL
  FROM TB_EMP_74 A
     , TB_DEPT_74 B
 WHERE A.DEPT_CD = B.DEPT_CD
 GROUP BY ROLLUP (B.DEPT_NM)
;
-------------------------------------------------------------------------------------------------------------
--76.
CREATE TABLE TB_EMP_76
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, JOB_NM VARCHAR2(150) NULL
, CUR_SAL NUMBER
, DEPT_CD CHAR(4)
, CONSTRAINT TB_EMP_76_PK PRIMARY KEY(EMP_NO)
)
;


INSERT INTO TB_EMP_76 VALUES ('100001', '이경오', 'SQL개발자'     , 80000000, 'D101');
INSERT INTO TB_EMP_76 VALUES ('100002', '이동민', '프로시저개발자', 60000000, 'D101');

INSERT INTO TB_EMP_76 VALUES ('100003', '김철수', '리눅스엔지니어', 40000000, 'D102');
INSERT INTO TB_EMP_76 VALUES ('100004', '박상진', '윈도우엔지니어', 20000000, 'D102');

COMMIT;

SELECT SUM(CUR_SAL)/10000
  FROM
 (
  SELECT A.EMP_NO
       , A.EMP_NM
       , LAG(CUR_SAL) OVER(ORDER BY CUR_SAL) AS LAG_CUR_SAL
       , LEAD(CUR_SAL) OVER(ORDER BY CUR_SAL) AS LEAD_CUR_SAL
       , CUR_SAL
    FROM TB_EMP_76 A
   ORDER BY A.EMP_NO
 ) A
 WHERE LAG_CUR_SAL IS NULL
    OR LEAD_CUR_SAL IS NULL
;
-------------------------------------------------------------------------------------------------------------
--77.
CREATE TABLE TB_DEPT_77
(
  DEPT_CD CHAR(4)
, DEPT_NM VARCHAR2(150) NOT NULL
, CONSTRAINT TB_DEPT_77_PK PRIMARY KEY(DEPT_CD)
)
;
CREATE TABLE TB_EMP_77
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, JOB_NM VARCHAR2(150) NULL
, CUR_SAL NUMBER
, DEPT_CD CHAR(4)
, CONSTRAINT TB_EMP_77_PK PRIMARY KEY(EMP_NO)
)
;

ALTER TABLE TB_EMP_77
ADD CONSTRAINT TB_EMP_77_FK FOREIGN KEY (DEPT_CD)
    REFERENCES TB_DEPT_77 (DEPT_CD);


INSERT INTO TB_DEPT_77 VALUES ('D101', '데이터개발팀'        );
INSERT INTO TB_DEPT_77 VALUES ('D102', '데이터플랫폼팀'      );
INSERT INTO TB_DEPT_77 VALUES ('D103', '데이터사이언스팀'    );
INSERT INTO TB_DEPT_77 VALUES ('D104', '데이터성능팀'        );
INSERT INTO TB_DEPT_77 VALUES ('D105', '데이터마이그레이션팀');
COMMIT;

INSERT INTO TB_EMP_77 VALUES ('100001', '이경오', 'SQL개발자', 45000000, 'D101');
INSERT INTO TB_EMP_77 VALUES ('100002', '이동민', 'SQL개발자', 40000000, 'D101');
INSERT INTO TB_EMP_77 VALUES ('100003', '김철수', 'SQL개발자', 40000000, 'D102');
INSERT INTO TB_EMP_77 VALUES ('100004', '박상진', 'SQL개발자', 35000000, 'D102');
INSERT INTO TB_EMP_77 VALUES ('100005', '박은정', 'SQL개발자', 50000000, 'D103');
INSERT INTO TB_EMP_77 VALUES ('100006', '김다연', 'SQL개발자', 45000000, 'D103');
INSERT INTO TB_EMP_77 VALUES ('100007', '박수진', 'SQL개발자', 65000000, 'D104');
INSERT INTO TB_EMP_77 VALUES ('100008', '김성수', 'SQL개발자', 60000000, 'D104');
INSERT INTO TB_EMP_77 VALUES ('100009', '추상미', 'SQL개발자', 35000000, 'D105');
INSERT INTO TB_EMP_77 VALUES ('100010', '박나래', 'SQL개발자', 30000000, 'D105');
COMMIT;

SELECT JOB_NM
     , B.DEPT_NM
     , AVG(A.CUR_SAL) AS CUR_SAL
  FROM TB_EMP_77 A
     , TB_DEPT_77 B
WHERE A.DEPT_CD = B.DEPT_CD
GROUP BY ROLLUP (A.JOB_NM, B.DEPT_NM)
;
-------------------------------------------------------------------------------------------------------------
--78.
CREATE TABLE TB_DEPT_78
(
  DEPT_NO CHAR(6)
, DEPT_NM VARCHAR2(150) NOT NULL
, UPPER_DEPT_NO CHAR(6) NULL
, CONSTRAINT TB_DEPT_78_PK PRIMARY KEY (DEPT_NO)
)
;

INSERT INTO TB_DEPT_78 VALUES ('D00001', '회장실'        ,  NULL   );

INSERT INTO TB_DEPT_78 VALUES ('D00002', '영업본부'      , 'D00001');
INSERT INTO TB_DEPT_78 VALUES ('D00003', '기술본부'      , 'D00001');

INSERT INTO TB_DEPT_78 VALUES ('D00004', '국내영업부'    , 'D00002');
INSERT INTO TB_DEPT_78 VALUES ('D00005', '해외영업부'    , 'D00002');

INSERT INTO TB_DEPT_78 VALUES ('D00006', '개발사업부'    , 'D00003');
INSERT INTO TB_DEPT_78 VALUES ('D00007', '데이터사업부'  , 'D00003');

INSERT INTO TB_DEPT_78 VALUES ('D00008', '기업영업팀'    , 'D00004');
INSERT INTO TB_DEPT_78 VALUES ('D00009', '공공영업팀'    , 'D00004');

INSERT INTO TB_DEPT_78 VALUES ('D00010', '북미영업팀'    , 'D00005');
INSERT INTO TB_DEPT_78 VALUES ('D00011', '남미영업팀'    , 'D00005');

INSERT INTO TB_DEPT_78 VALUES ('D00012', '서버개발팀'    , 'D00006');
INSERT INTO TB_DEPT_78 VALUES ('D00013', '화면개발팀'    , 'D00006');

INSERT INTO TB_DEPT_78 VALUES ('D00014', '오라클기술팀'  , 'D00007');
INSERT INTO TB_DEPT_78 VALUES ('D00015', '오픈소스기술팀', 'D00007');

COMMIT;

SELECT DEPT_NO, LPAD(' ', 4 * (LEVEL -1)) || DEPT_NM AS DEPT_NM
     , UPPER_DEPT_NO
     , LEVEL AS LVL
 FROM TB_DEPT_78
 START WITH UPPER_DEPT_NO IS NULL
 CONNECT BY PRIOR DEPT_NO = UPPER_DEPT_NO
              AND DEPT_NM LIKE '영업%'
 ;
-------------------------------------------------------------------------------------------------------------
--80.
CREATE TABLE TB_DEPT_80
(
  DEPT_NO CHAR(6)
, DEPT_NM VARCHAR2(150) NOT NULL
, CONSTRAINT TB_DEPT_80_PK PRIMARY KEY (DEPT_NO)
)
;

INSERT INTO TB_DEPT_80 VALUES ('D00001', 'Data시각화팀');
INSERT INTO TB_DEPT_80 VALUES ('D00002', 'Data플랫폼팀');
INSERT INTO TB_DEPT_80 VALUES ('D00003', 'Data분석팀'  );

COMMIT;

CREATE TABLE TB_EMP_80
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, DEPT_NO CHAR(6)
, CONSTRAINT TB_EMP_80_PK PRIMARY KEY (EMP_NO)
)
;

INSERT INTO TB_EMP_80 VALUES ('E00001', '이경오', 'D00001');
INSERT INTO TB_EMP_80 VALUES ('E00002', '이수지', 'D00001');
INSERT INTO TB_EMP_80 VALUES ('E00003', '김효선', 'D00002');
INSERT INTO TB_EMP_80 VALUES ('E00004', '박상진', 'D00003');


COMMIT;

ALTER TABLE TB_EMP_80
ADD CONSTRAINTS TB_EMP_80_FK FOREIGN KEY (DEPT_NO)
REFERENCES TB_DEPT_80 (DEPT_NO)
;

SELECT A.DEPT_NO
     , A.DEPT_NM
     , NVL(B.EMP_NO, 'NULL') AS EMP_NO
     , NVL(B.EMP_NM, 'NULL') AS EMP_NM
  FROM TB_DEPT_80 A LEFT OUTER JOIN TB_EMP_80 B
    ON (A.DEPT_NO = B.DEPT_NO AND A.DEPT_NM = 'Data시각화팀')
  WHERE A.DEPT_NO IS NOT NULL
;

